import React from "react";
import { Socket, Namespace } from "socket.io";
interface ConnectionProps {
    onConnection?: (socket: Socket) => void;
    children?: (socket: Socket) => React.ReactNode;
}
interface ConnectionState {
    connections: {
        socket: Socket;
        id: string;
        children: React.ReactNode;
    }[];
}
declare class Connection extends React.Component<ConnectionProps, ConnectionState> {
    state: ConnectionState;
    static contextType: React.Context<Namespace | undefined>;
    componentDidMount: () => void;
    render(): JSX.Element;
}
export default Connection;
