import React from "react";
interface OnProps<Data = any> {
    handler?: (data: Data) => void;
    children?: (data: Data) => React.ReactNode;
    event: string;
    off?: boolean;
}
interface OnState {
    children?: React.ReactNode;
}
declare class On<Data> extends React.Component<OnProps<Data>, OnState> {
    state: OnState;
    private onUpdateIndex;
    private onDidUpdate;
    componentWillUnmount: () => void;
    render(): JSX.Element;
}
export default On;
