"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var On = /** @class */ (function (_super) {
    __extends(On, _super);
    function On() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {};
        _this.onUpdateIndex = 0;
        _this.onDidUpdate = function (namespace) {
            _this.onUpdateIndex++;
            if (namespace) {
                var updateIndex_1 = _this.onUpdateIndex;
                namespace.on(_this.props.event, function (data) {
                    if (_this.onUpdateIndex === updateIndex_1) {
                        if (_this.props.children) {
                            _this.setState({ children: _this.props.children(data) });
                        }
                        if (_this.props.handler)
                            _this.props.handler(data);
                    }
                });
            }
        };
        _this.componentWillUnmount = function () {
            _this.onUpdateIndex++;
        };
        return _this;
    }
    On.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(context_1.NamespaceContext.Consumer, null, function (namespace) {
            _this.onDidUpdate(namespace);
            return _this.state.children;
        }));
    };
    return On;
}(react_1.default.Component));
exports.default = On;
