"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var Room = /** @class */ (function (_super) {
    __extends(Room, _super);
    function Room() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderIndex = 0;
        return _this;
    }
    Room.prototype.render = function () {
        var _this = this;
        this.renderIndex++;
        var currentRenderIndex = this.renderIndex;
        return (react_1.default.createElement(context_1.NamespaceContext.Consumer, null, function (namespace) {
            if (namespace) {
                var roomNamespace = namespace.in(_this.props.room);
                roomNamespace.on("connection", function () { return _this.renderIndex === currentRenderIndex && _this.props.onJoin; });
                return (react_1.default.createElement(context_1.NamespaceContext.Provider, { value: roomNamespace }, _this.props.children));
            }
            return react_1.default.createElement(react_1.default.Fragment, null);
        }));
    };
    return Room;
}(react_1.default.Component));
exports.default = Room;
