/// <reference types="node" />
import React from "react";
import { Server as SocketServer } from "socket.io";
import { Server as HTTPServer } from "http";
export interface ServerProps {
    reference?: (appRef: SocketServer, httpServerRef?: HTTPServer) => void;
    then?: () => void;
    port: number;
    listen: boolean;
}
declare class Server extends React.Component<ServerProps> {
    private app;
    private server?;
    constructor(props: Server["props"]);
    createServer: () => void;
    shouldComponentUpdate: (nextProps: Server["props"]) => boolean;
    render(): JSX.Element;
}
export default Server;
