"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var socket_io_1 = __importDefault(require("socket.io"));
var http_1 = require("http");
var context_1 = require("../context");
var Server = /** @class */ (function (_super) {
    __extends(Server, _super);
    function Server(props) {
        var _this = _super.call(this, props) || this;
        _this.app = socket_io_1.default();
        _this.createServer = function () {
            var _a = _this.props, port = _a.port, then = _a.then, reference = _a.reference;
            _this.server = http_1.createServer();
            _this.server.listen(port);
            _this.app.listen(_this.server);
            if (then)
                _this.server.on("close", then);
            if (reference)
                reference(_this.app, _this.server);
        };
        _this.shouldComponentUpdate = function (nextProps) {
            if (nextProps.listen !== _this.props.listen ||
                nextProps.port !== _this.props.port) {
                if (nextProps.listen !== _this.props.listen && !nextProps.listen) {
                    if (_this.server)
                        _this.server.close();
                }
                if (nextProps.port !== _this.props.port) {
                    if (nextProps.listen) {
                        if (_this.props.listen) {
                            if (_this.server)
                                _this.server.close();
                        }
                        _this.createServer();
                    }
                }
                else {
                    if (nextProps.listen !== _this.props.listen && nextProps.listen) {
                        _this.createServer();
                    }
                }
            }
            if (!_this.props.reference && nextProps.reference) {
                nextProps.reference(_this.app, _this.server);
            }
            return false;
        };
        if (props.listen && props.port) {
            _this.createServer();
        }
        return _this;
    }
    Server.prototype.render = function () {
        return (react_1.default.createElement(context_1.ServerContext.Provider, { value: this.app },
            react_1.default.createElement(context_1.NamespaceContext.Provider, { value: this.app }, this.props.children)));
    };
    return Server;
}(react_1.default.Component));
exports.default = Server;
