import React from "react";
import { Socket } from "socket.io";
import { DefaultEventType } from "../types";
declare abstract class Component<Props extends object = {}, State extends object = {}, EmitEvents extends DefaultEventType = DefaultEventType> extends React.Component<State, Props> {
    static contextType: React.Context<import("socket.io").Namespace | undefined>;
    protected get socket(): Socket;
    protected emit: <Event_1 extends keyof EmitEvents>(event: Event_1, data: EmitEvents[Event_1]) => boolean;
}
export default Component;
